--[[this is the vlua section of Retry, it is called by ge/extensions/raceTools/geResetWSpeed.setRetryPosSpeed to set transmission values
and then raceTools/geResetWSpeed.retryWithSpeed to use these values. It's not perfect, so setting the transmission needs to be looped]]--
local M = {}

local rgearNum = 0 --what gear the car is in, vehicle.vehicleController.getGearName
local rGearName = 0 --auto selector
local rGearMode --arcade or realistic
local setRPM = 0 --engine rpm
local timeLooperA = 0
local timeLooperM = 0
local manualBUsed = false
local resetTime = 10--test this with 0?
local hasUsedRetry = true

--history table
local hisTab = {}

--powertrainrpms
local poRPMHis = {}

--wheel speed thrust values
local thrushAmount = 0
local previousNodeKey = 0
local firstWheelNode = 0
local secondWheelNode = 0

local function onExtensionLoaded()
    --obj:queueGameEngineLua([[extensions.load("raceTools_geResetWSpeed")]])
    --obj:queueGameEngineLua("raceTools_geResetWSpeed.hasRetrySet = false")
    timeLooperA = 0
    timeLooperM = 0
    rgearNum = 0
    rGearName = 0
    --hasUsedRetry = true
    resetTime = 5--test this with 0?
    manualBUsed = false
    obj:queueGameEngineLua("raceTools_geResetWSpeed.GEclearEntry(".. obj:getId() ..")")
end

local function VEclearEntry()
    hisTab = nil
    poRPMHis = nil
    hisTab = {}
    poRPMHis = {}
    print("clearing out VE retry table")
end

local function onReset()
    --hasUsedRetry = true
end

local function roughlyEqual(a, b)
    return math.abs(a - b) < 0.05
end

local function veSetRetryValues(lenCheck) --SETTING
    local setTab = {
        rgearNum = electrics.values.gearIndex,
        rGearName = electrics.values.gear_A, --a number from 0 (park) to 1 (prnd2) 1 postion
        rGearMode = tostring(electrics.values.gearboxMode),
        setRPM = electrics.values.rpm
    }

    local poRPM = {}
    local layer = {}
    for _, device in pairs(powertrain.getDevices()) do --this makes a 
        layer[device.name] = device.outputAV1
        table.insert(poRPM, layer)
        poRPM[device.name] = device.outputAV1
        --print("cycling devices- "..tostring(device.name)..", "..tostring(device.outputAV1))
    end
    table.insert(hisTab, 1, setTab)
    table.insert(poRPMHis, 1, poRPM)

end

local function addWheelRotation()
    previousNodeKey = 0
    for a, wheelID in pairs(wheels.wheels) do
        if wheelID.name == "FR" or wheelID.name == "RR" then
            thrushAmount = -10000
        else
            thrushAmount = 10000
        end
        for c,d in ipairs(wheelID.nodes) do
            if c == 1 then
                firstWheelNode = d
                secondWheelNode = d+1
            end
            if c >= 3 and previousNodeKey then
                obj:applyForce(d-2, d, thrushAmount)
                previousNodeKey = c
            else
                if c >=3 then
                    obj:applyForce(d-1, firstWheelNode, thrushAmount)
                    obj:applyForce(d, secondWheelNode, thrushAmount)
                    previousNodeKey = 0
                end
            end
            
        end
        for c,d in ipairs(wheelID.treadNodes) do
            if c == 1 then
                firstWheelNode = d
                secondWheelNode = d+1
            end
            if c >= 3 and previousNodeKey then
                obj:applyForce(d-2, d, thrushAmount)
                previousNodeKey = c
            else
                if c >=3 then
                    obj:applyForce(d-1, firstWheelNode, thrushAmount)
                    obj:applyForce(d, secondWheelNode, thrushAmount)
                    previousNodeKey = 0
                end
            end
        end
    end
    
end

local veVer = 1
local wheelSpeedButtonUsed = false
local function veUseRetryValues(geVer) --USING RETRY
    veVer = geVer --this is getting the GELua history version to reset to
    resetTime = 0
    hasUsedRetry = true

    --print("VLUA USE Retry, gear_A="..electrics.values.gear_A..", wanted auto value="..hisTab[geVer].rGearName)
    if electrics.values.parkingbrakelight >= 0 then --Parking Break flipper
        input.toggleEvent('parkingbrake')
    end

    drivetrain.engineAV = setRPM * math.pi * 2 / 60
    controller.mainController.shiftToGearIndex(hisTab[geVer].rgearNum) --make sure in correct gear 
    if type(hisTab[geVer].rGearName) == "number" and hisTab[geVer].rGearName >= 0.02 then --tell updateGFX to start cycling gears
        timeLooperA = 6
        print("you have an auto, yuck")
    else
        timeLooperM = 6
        manualBUsed = true
        --print("you have a manual. A man of taste")
    end
    wheelSpeedButtonUsed = true

    for name,rpm in pairs(poRPMHis[veVer])do--here we open the rpm history table to the version we want, and loop for each entry
        if type(rpm)~="table" then
            --print(name.." -name,rpm- "..tostring(rpm))
            local ptra = powertrain.getDevice(name)--here we get the divice with our name
            ptra.outputAV1 = rpm--here we have the device, and set it's ouputAV1 to our history's rpm value
        end
    end
end

local function updateGFX(dt)

    if hasUsedRetry then --slowmotion start and deactivation. Also initially set in GE so it starts on first frame
        resetTime = resetTime + dt
        local slowmoSpeed = math.max(0, math.min(1, resetTime))
        obj:queueGameEngineLua('simTimeAuthority.set('..tostring(resetTime)..')')
        if resetTime >= 1 then
            hasUsedRetry = false
        end
    end

    if wheelSpeedButtonUsed then
        if electrics.values.wheelspeed <= electrics.values.airspeed then
            addWheelRotation()
        else
            wheelSpeedButtonUsed = false
        end
    end


    if timeLooperA >= 0.5 then --you have a poo in your pants
        if not roughlyEqual(electrics.values.gear_A, hisTab[veVer].rGearName) then
            if electrics.values.gearboxMode == "arcade" then
                controller.mainController.cycleGearboxModes()
            end
            if electrics.values.gear_A <= hisTab[veVer].rGearName then --setting auto shifter position
                if controller.mainController.shiftUpOnDown then
                    controller.mainController.shiftUpOnDown()
                else
                    controller.mainController.shiftUp()
                end
            else
                if controller.mainController.shiftDownOnDown then
                    controller.mainController.shiftDownOnDown()
                else
                    controller.mainController.shiftDown()
                end
            end
        else --ending trans loop
            timeLooperA = timeLooperA - 1
            if electrics.values.gearboxMode ~= hisTab[veVer].rGearMode then
                controller.mainController.cycleGearboxModes()
            end
        end
    end

    if manualBUsed then
        if rgearNum == electrics.values.gearIndex then
            controller.mainController.setGearboxMode(hisTab[veVer].rGearMode)
            manualBUsed = false
        end
    end

end

M.VEclearEntry = VEclearEntry
M.veTestButton = veTestButton
M.veSetRetryValues = veSetRetryValues
M.veUseRetryValues = veUseRetryValues

M.onExtensionLoaded = onExtensionLoaded
M.onReset = onReset
M.updateGFX = updateGFX

return M

--[[notes

    ]]--